=== debian/changelog ===
ros-indigo-orogen (2.8.0-0trusty) trusty; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- OCL Development Team <orocos-dev@lists.mech.kuleuven.be>  Mon, 26 Jan 2015 17:33:29 -0000
